#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <ctime>

using namespace std;

//**************
//* Exercice 1 *
//**************

double exp_v1(double x,size_t n){
  //num = x^k
  //den = k!
  //  t = num/den

  //Init pour k=0
  double num=1; 
  double den=1;
  double t=num/den;
  double s=t;

  for(size_t k=1;k<=n;++k){
    num*=x;
    den*=k;
    t=num/den;
    s+=t;
  }
  return s;
}

double exp_v2(double x,double p){
  //num = x^k
  //den = k!
  //  t = num/den

  //Init pour k=0
  double num=1; 
  double den=1;
  double t=num/den;
  double s=t;
  size_t k=0;
  
  while(t>=p){
    ++k;
    num*=x;
    den*=k;
    t=num/den;
    s+=t;
  }
  return s;
}

//**************
//* Exercice 2 *
//**************
double arctan_v1(double x,size_t n){
  //Pour k=0
  double num=x;
  double den=1;
  double terme=num/den;
  double s=terme;
  for(size_t k=1;k<=n;++k){
    num=num*(-x*x);
    den+=2;
    terme=num/den;
    s+=terme;
  }
  return s;
}

//**************
//* Exercice 3 *
//**************

double sqrt(double a,size_t n){
  double u=1; //u_0
  for(size_t k=1;k<=n;++k){
    u=(u+a/u)/2;
  }
  return(u);
}

//**************
//* Exercice 7 *
//**************

double hyperbole(double x){
  return 1/x;
}

typedef double(*Fonction)(double); //Fonction désigne les fonction double->double

double methode_rectangle(Fonction f,double a,double b,size_t n){
  double s=0;
  double xg=a; //xg=x_0
  double l=(b-a)/n;
  double xd=xg+l; //xd=x_0+(b-a)/n=x_1
  for(size_t k=1;k<=n;++k){
    s+=(f(xg)+f(xd));
    xg+=l;
    xd+=l;
  }
  return l/2*s;
}

double methode_simpson(Fonction f,double a,double b,size_t n){
  double s=0;
  double xg=a; //xg=x_0
  double l=(b-a)/n;
  double xd=xg+l; //xd=x_0+(b-a)/n=x_1
  for(size_t k=1;k<=n;++k){
    //Approximation de f(x) sur [xg,xd] par g(x)=a*(x-xg)^2+b*(x-xg)+c
    double xm=(xg+xd)/2;
    double yg=f(xg);
    double ym=f(xm);
    double yd=f(xd);
    double c=yg;
    double b=(-3*yg+4*ym-yd)/l;
    double a=(2*yg-4*ym+2*yd)/(l*l);
    //Aprroximation de l'intégrale de f(x) sur [xg,xd] est
    double approx=a*(l*l*l)/3+b*(l*l)/2+c*l;
    s+=approx;
    xg+=l;
    xd+=l;
  }
  return s;
}

//**************
//* Exercice 7 *
//**************

double alea(){
  return ((double)rand())/RAND_MAX;
}

double monte_carlo(size_t n){
  size_t nc=0; //Nombre de flêches dans la cible
  for(size_t k=0;k<n;++k){
    double x=alea();
    double y=alea();
    if(x*x+y*y<=1) ++nc;
  }
  return ((double)(4*nc))/n;
}

//**************
//* Exercice 9 *
//**************

double f(double x){
  return sqrt(1-x*x,20);
}

double pi_rectangle(size_t n){
  return 4*methode_rectangle(f,0,1,n);
}

double pi_simpson(size_t n){
  return 4*methode_simpson(f,0,1,n);
}

//***************
//* Exercice 10 *
//***************

double machin(size_t n){
  return 4*(4*arctan_v1(1.0/5.0,n)-arctan_v1(1.0/239.0,n));
}

//********
//* Main *
//********

int main(){
  srand (time(NULL));
  cout<<setprecision(20);
  cout<<"********************"<<endl;
  cout<<"* 1 - Introduction *"<<endl;
  cout<<"********************"<<endl;
  cout<<endl;
  cout<<"==> Exercice 1"<<endl;
  cout<<"--> Question 1"<<endl;
  cout<<"exp_v1(1,10) = "<<exp_v1(1,10)<<endl;
  cout<<"exp_v1(1,10) = "<<exp_v1(1,15)<<endl;
  cout<<"exp_v1(1,10) = "<<exp_v1(1,20)<<endl;
  cout<<"exp_v1(1,10) = "<<exp_v1(1,25)<<endl;
  cout<<"--> Question 2 "<<endl;
  cout<<"exp_v2(1,1e-5) = "<<exp_v2(1,1e-5)<<endl;
  cout<<"exp_v2(1,1e-10) = "<<exp_v2(1,1e-10)<<endl;
  cout<<endl;
  cout<<"==> Exercice 2"<<endl;
  cout<<"--> Question 1"<<endl;
  cout<<"arctan_v1(-0.7,10) = "<<arctan_v1(-0.7,10)<<endl;
  cout<<"arctan_v1(-0.7,20) = "<<arctan_v1(-0.7,20)<<endl;
  cout<<endl;
  cout<<"==> Exercice 3"<<endl;
  cout<<"sqrt(2,5) = "<<sqrt(2,5)<<endl;
  cout<<"sqrt(2,10) = "<<sqrt(2,10)<<endl;
  cout<<"sqrt(4,10) = "<<sqrt(4,10)<<endl;
  cout<<"sqrt(5,10) = "<<sqrt(5,10)<<endl;
  cout<<endl;
  cout<<"==> Exercide 7"<<endl;
  cout<<"Methode rectangle "<<endl;
  cout<<" ln(2) pour n=10 : "<<methode_rectangle(hyperbole,1,2,10)<<endl;
  cout<<" ln(2) pour n=100 : "<<methode_rectangle(hyperbole,1,2,100)<<endl;
  cout<<" ln(2) pour n=1000 : "<<methode_rectangle(hyperbole,1,2,1000)<<endl;
  cout<<"Methode Simpson "<<endl;
  cout<<" ln(2) pour n=10 : "<<methode_simpson(hyperbole,1,2,10)<<endl;
  cout<<" ln(2) pour n=100 : "<<methode_simpson(hyperbole,1,2,100)<<endl;
  cout<<" ln(2) pour n=1000 : "<<methode_simpson(hyperbole,1,2,1000)<<endl;
  cout<<endl;
  cout<<"==> Exercice 8"<<endl;
  cout<<" Pi monte_carlo(100) : "<<monte_carlo(100)<<endl;
  cout<<" Pi monte_carlo(1000) : "<<monte_carlo(1000)<<endl;
  cout<<" Pi monte_carlo(10000) : "<<monte_carlo(10000)<<endl;
  cout<<" Pi monte_carlo(100000) : "<<monte_carlo(100000)<<endl;
  cout<<" Pi monte_carlo(1000000) : "<<monte_carlo(100000)<<endl;
  cout<<" Pi monte_carlo(1000000) : "<<monte_carlo(1000000)<<endl;
  cout<<endl;
  cout<<"==> Exercide 9"<<endl;
  cout<<" -> Methode des rectangles"<<endl;
  cout<<" Pi rectangle(100) : "<<pi_rectangle(100)<<endl;
  cout<<" Pi rectangle(1000) : "<<pi_rectangle(1000)<<endl;
  cout<<" Pi rectangle(10000) : "<<pi_rectangle(10000)<<endl;
  cout<<" Pi rectangle(100000) : "<<pi_rectangle(100000)<<endl;
  cout<<" Pi rectangle(1000000) : "<<pi_rectangle(1000000)<<endl;
  cout<<endl;
  cout<<" -> Methode de Simpson"<<endl;
  cout<<" Pi simpson(100) : "<<pi_simpson(100)<<endl;
  cout<<" Pi simpson(1000) : "<<pi_simpson(1000)<<endl;
  cout<<" Pi simpson(10000) : "<<pi_simpson(10000)<<endl;
  cout<<" Pi simpson(100000) : "<<pi_simpson(100000)<<endl;
  cout<<" Pi simpson(1000000) : "<<pi_simpson(1000000)<<endl;
  cout<<endl;
  cout<<"==> Exercide 10"<<endl;
  cout<<endl;
  cout<<" Pi Machin(10) : "<<machin(10)<<endl;
}
